## gemrb 0.6.5-2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.4)
if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
	cmake_policy(SET CMP0005 NEW)
endif(COMMAND cmake_policy)
# allow empty else and endif constructs (available by default since 2.6.0)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

# prevent in-source builds
IF(NOT INSOURCEBUILD AND (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR}))
	MESSAGE(FATAL_ERROR "
		CMake generation for this project is not allowed within the source directory!
		Remove the CMake cache files and try again from another folder, e.g.:
		  rm -r CMakeCache.txt CMakeFiles/
		  mkdir build
		  cd build
		  cmake ..
		If you really want an in-source build, pass -DINSOURCEBUILD=1"
	)
ENDIF()

# If the user specifies -DCMAKE_BUILD_TYPE on the command line, take their definition
# and dump it in the cache along with proper documentation, otherwise set CMAKE_BUILD_TYPE
# to Release prior to calling PROJECT()
IF(DEFINED CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ELSE(DEFINED CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ENDIF(DEFINED CMAKE_BUILD_TYPE)

PROJECT(gemrb)
# try to extract the version from the source
execute_process(
	COMMAND sed -n "s/\#define VERSION_GEMRB .\\([^\"]*\\).$/\\1/p" ${CMAKE_CURRENT_SOURCE_DIR}/gemrb/includes/globals.h
	OUTPUT_VARIABLE GEMRB_VERSION
	RESULT_VARIABLE RC
	OUTPUT_STRIP_TRAILING_WHITESPACE
)
if(${RC} GREATER 0) # lookup failed
	set(GEMRB_VERSION "unknown")
endif(${RC} GREATER 0)
message("Detected version: ${GEMRB_VERSION}")

IF(PREFIX)
	SET(PREFIX CACHE PATH "Abbreviation for CMAKE_INSTALL_PREFIX.")
	SET(CMAKE_INSTALL_PREFIX ${PREFIX})
ENDIF(PREFIX)

if (NOT LAYOUT)
	if (WIN32)
		set(LAYOUT "home")
	else (WIN32)
		set(LAYOUT "fhs")
	endif (WIN32)
endif (NOT LAYOUT)

SET(LAYOUT "${LAYOUT}" CACHE STRING "Directory layout.")

# macro that sets a default (path) if one wasn't specified
MACRO(SET_PATH variable default)
	IF(NOT ${variable})
		SET(${variable} ${default})
	ENDIF(NOT ${variable})
ENDMACRO(SET_PATH)

if (${LAYOUT} MATCHES "home")
	SET_PATH( PLUGIN_DIR ${CMAKE_INSTALL_PREFIX}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX} )
elseif (${LAYOUT} MATCHES "fhs")
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib/gemrb )
	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/gemrb )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/share/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin )
	IF( NOT SYSCONF_DIR )
		if ( ${CMAKE_INSTALL_PREFIX} STREQUAL "/usr" )
			SET( SYSCONF_DIR /etc/gemrb )
		else ()
			SET( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX}/etc/gemrb )
		endif ()
	ENDIF( NOT SYSCONF_DIR )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/gemrb )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
else (${LAYOUT} MATCHES "opt")
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib )
	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/ )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin )
	SET_PATH( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX}/etc )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/gemrb )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
endif (${LAYOUT} MATCHES "home")

# check if this is a release version
execute_process(
	COMMAND echo ${GEMRB_VERSION}
	COMMAND grep -q git # cmake creates a pipe by itself
	RESULT_VARIABLE RC
	OUTPUT_QUIET
)
if(${RC} GREATER 0) # no match or error
	set (GIT_VERSION 0)
else()
	set (GIT_VERSION 1)
endif()

IF(CMAKE_COMPILER_IS_GNUCXX)
	if ((NOT DISABLE_WERROR) AND GIT_VERSION)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
	endif ()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W -Wpointer-arith -Wcast-align")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-format-y2k -Wno-long-long -fno-strict-aliasing")
	# only export symbols explicitly marked to be exported.
	INCLUDE(CheckCXXCompilerFlag)
	CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" VISIBILITY_HIDDEN)
	IF (VISIBILITY_HIDDEN AND NOT WIN32)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
	ENDIF ()
	if (WIN32)
		# GCC 4.5.0+ has shared libstdc++ without dllimport
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--enable-auto-import")
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--enable-auto-import")
	endif (WIN32)
	# Ensure all plugin symbols exist.
	if (NOT APPLE AND NOT UNSAFE_PLUGIN)
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
	endif (NOT APPLE AND NOT UNSAFE_PLUGIN)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# Check for all the required and optional dependencies
INCLUDE(FindPythonLibs)
IF(PYTHONLIBS_FOUND)
	MESSAGE(STATUS "Looking for Python libraries and headers: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for Python libraries and headers: not found!")
	MESSAGE(FATAL_ERROR "Please get them (www.python.org)")
ENDIF()

INCLUDE(FindSDL)
IF(SDL_FOUND)
	MESSAGE(STATUS "Looking for SDL: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for SDL: not found!")
	MESSAGE(FATAL_ERROR "Please get it from www.libsdl.org")
ENDIF()

INCLUDE(FindZLIB)
IF(ZLIB_FOUND)
	MESSAGE(STATUS "Looking for Zlib: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for Zlib: not found!")
	MESSAGE(FATAL_ERROR "Please install the Zlib library and headers first!")
ENDIF()

IF(UNIX)
	SET(CMAKE_THREAD_PREFER_PTHREAD true)
	FIND_PACKAGE(Threads REQUIRED)
ENDIF(UNIX)

INCLUDE(FindOpenAL)
IF(OPENAL_FOUND)
	MESSAGE(STATUS "Looking for OpenAL: found")
ELSE()
	MESSAGE(WARNING "Looking for OpenAL: not found!")
	MESSAGE(WARNING "If you want to build the OpenAL plugin, get OpenAL from www.openal.org.")
	MESSAGE(WARNING "If it just wasn't found, try setting the OPENALDIR environment variable.")
ENDIF()

INCLUDE(FindSDL_mixer)
IF(SDLMIXER_FOUND)
	MESSAGE(STATUS "Looking for SDL_mixer: found")
ELSE()
	MESSAGE(WARNING "Looking for SDL_mixer: not found!")
	MESSAGE(WARNING "If you want to build the SDL_mixer plugin, install SDL_mixer first.")
ENDIF()

INCLUDE(FindPNG)
IF(PNG_FOUND)
	MESSAGE(STATUS "Looking for libPNG: found")
ELSE()
	MESSAGE(WARNING "Looking for libPNG: not found!")
	MESSAGE(WARNING "GemRB will be built without any PNG support. Get it from www.libpng.org" )
	MESSAGE(WARNING "While no original game data is in PNG format, some mod data is and will need conversion.")
ENDIF()

FIND_LIBRARY(VORBIS_LIBRARY vorbisfile)
IF(VORBIS_LIBRARY)
	find_path(VORBIS_FILE vorbisfile.h PATH_SUFFIXES vorbis)
	IF(VORBIS_FILE)
		MESSAGE(STATUS "Looking for Ogg Vorbis support: found")
	ELSE()
		unset(VORBIS_LIBRARY) # disable the build for this plugin
	ENDIF()
ENDIF()
IF(NOT VORBIS_LIBRARY)
	MESSAGE(WARNING "Looking for Ogg Vorbis support: not found!")
	MESSAGE(WARNING "While no original game data is in OGG format, some mod data is and will need conversion.")
ENDIF()

ADD_DEFINITIONS("-DHAVE_CONFIG_H")

# On Release builds cmake automatically defines NDEBUG, so we
# explicitly undefine it:
if(CMAKE_BUILD_TYPE STREQUAL "Release" AND NOT MSVC)
	ADD_DEFINITIONS("-UNDEBUG")
endif()

if (STATIC_LINK)
	if (NOT WIN32)
		ADD_DEFINITIONS("-DSTATIC_LINK")
	else (NOT WIN32)
		unset(STATIC_LINK CACHE)
		MESSAGE(STATUS "Static linking not (yet) supported on this platform.")
	endif (NOT WIN32)
endif (STATIC_LINK)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} gemrb/includes gemrb/core)

#Platform checks
INCLUDE (CheckTypeSize)
CHECK_TYPE_SIZE("int" SIZEOF_INT)
CHECK_TYPE_SIZE("long int" SIZEOF_LONG_INT)

INCLUDE (CheckFunctionExists)
CHECK_FUNCTION_EXISTS("strndup" HAVE_STRNDUP)

CHECK_INCLUDE_FILES("unistd.h" HAVE_UNISTD_H)
CHECK_INCLUDE_FILES("malloc.h" HAVE_MALLOC_H)

#Unneeded on windows
IF(NOT WIN32)
	INCLUDE (CheckCXXSourceCompiles)
	CHECK_CXX_SOURCE_COMPILES("typedef void *(* voidvoid)(void);

		void *object = 0;
		voidvoid function;
		function = (voidvoid) object;
		" PERMITS_OBJECT_TO_FUNCTION_CAST)

	IF( NOT PERMITS_OBJECT_TO_FUNCTION_CAST )
		SET(HAVE_FORBIDDEN_OBJECT_TO_FUNCTION_CAST 1)
	ENDIF( NOT PERMITS_OBJECT_TO_FUNCTION_CAST )
ENDIF(NOT WIN32)

IF(APPLE)
	FIND_LIBRARY(SDL_MAIN_LIBRARY_PATH SDLmain)
	FIND_LIBRARY(COCOA_LIBRARY_PATH Cocoa)
ENDIF(APPLE)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake_config.h.in
	${CMAKE_CURRENT_BINARY_DIR}/config.h ESCAPE_QUOTES)

#Plugin addition macro
MACRO(ADD_GEMRB_PLUGIN plugin_name)
	if (STATIC_LINK)
		ADD_LIBRARY(${plugin_name} STATIC ${ARGN})
		set(plugins "${plugins};${plugin_name}" PARENT_SCOPE)
	else (STATIC_LINK)
		ADD_LIBRARY(${plugin_name} MODULE ${ARGN})
		if (NOT UNSAFE_PLUGIN)
			TARGET_LINK_LIBRARIES(${plugin_name} gemrb_core ${CMAKE_THREAD_LIBS_INIT})
		endif (NOT UNSAFE_PLUGIN)
		INSTALL(TARGETS ${plugin_name} DESTINATION ${PLUGIN_DIR})
	endif (STATIC_LINK)
	SET_TARGET_PROPERTIES(${plugin_name} PROPERTIES PREFIX ""
		INSTALL_RPATH ${LIB_DIR}
		LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/gemrb/plugins)
ENDMACRO(ADD_GEMRB_PLUGIN)

#gemrb overrides macro
MACRO(ADD_GEMRB_OVERRIDE game_name)
	FILE( GLOB FILES_TO_INSTALL *.2da *.bmp *.ini *.chu *.ids *.bcs *.vvc *.mos *.spl *.wav *.pro)
	INSTALL( FILES ${FILES_TO_INSTALL} DESTINATION ${DATA_DIR}/override/${game_name} )
ENDMACRO(ADD_GEMRB_OVERRIDE )

# also put the chosen paths in the man page (Ubuntu)
CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/gemrb.6.in"
	"${CMAKE_CURRENT_BINARY_DIR}/gemrb.6"
	IMMEDIATE @ONLY
)

ADD_SUBDIRECTORY( gemrb )
INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/gemrb.6" DESTINATION ${MAN_DIR} )
INSTALL( FILES artwork/gemrb-logo.png DESTINATION ${ICON_DIR} RENAME gemrb.png )
INSTALL( FILES artwork/logo04-rb_only.svg DESTINATION ${SVG_DIR} RENAME gemrb.svg )
INSTALL( FILES gemrb.desktop DESTINATION ${MENU_DIR} )
INSTALL( FILES README INSTALL COPYING NEWS AUTHORS DESTINATION ${DOC_DIR} )

CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY
)

# copy the variable, since the file uses @VERSION@
set(VERSION ${GEMRB_VERSION})
CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/gemrb.spec.in"
	"${CMAKE_CURRENT_BINARY_DIR}/gemrb.spec"
	IMMEDIATE @ONLY
)

ADD_CUSTOM_TARGET( uninstall
	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" )

# make dist for a gzipped tarball of current HEAD
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${GEMRB_VERSION})
add_custom_target( dist
	COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
		| gzip --best > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.gz
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

# pretty-print options macro
# as of 2.8 cmake does not support anything like EVAL
MACRO(PRINT_OPTION option name)
if (${option})
	message(STATUS "  ${name}: ${option}")
else()
	message(STATUS "  ${name}: disabled")
endif()
ENDMACRO(PRINT_OPTION)

message(STATUS "")
message(STATUS "These are the configured paths:")
message(STATUS "  PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "  LIB_DIR: ${LIB_DIR}")
message(STATUS "  PLUGIN_DIR: ${PLUGIN_DIR}")
message(STATUS "  BIN_DIR: ${BIN_DIR}")
message(STATUS "  DATA_DIR: ${DATA_DIR}")

=== gemrb/core/CMakeLists.txt ===
ADD_DEFINITIONS(-DGEM_BUILD_DLL)

FILE(GLOB gemrb_core_LIB_SRCS
	ActorMgr.cpp
	Ambient.cpp
	AmbientMgr.cpp
	Animation.cpp
	AnimationFactory.cpp
	AnimationMgr.cpp
	ArchiveImporter.cpp
	Audio.cpp
	Bitmap.cpp
	Cache.cpp
	Calendar.cpp
	Callback.cpp
	CharAnimations.cpp
	Compressor.cpp
	ControlAnimation.cpp
	Core.cpp
	DataFileMgr.cpp
	Dialog.cpp
	DialogHandler.cpp
	DialogMgr.cpp
	DisplayMessage.cpp
	EffectMgr.cpp
	EffectQueue.cpp
	Factory.cpp
	FactoryObject.cpp
	FileCache.cpp
	Font.cpp
	Game.cpp
	GameData.cpp
	GlobalTimer.cpp
	Image.cpp
	ImageFactory.cpp
	ImageMgr.cpp
	ImageWriter.cpp
	IndexedArchive.cpp
	IniSpawn.cpp
	Interface.cpp
	Inventory.cpp
	Item.cpp
	ItemMgr.cpp
	KeyMap.cpp
	LRUCache.cpp
	Map.cpp
	MapMgr.cpp
	MoviePlayer.cpp
	MusicMgr.cpp
	Palette.cpp
	PalettedImageMgr.cpp
	Particles.cpp
	Plugin.cpp
	PluginLoader.cpp
	PluginMgr.cpp
	Polygon.cpp
	Projectile.cpp
	ProjectileMgr.cpp
	ProjectileServer.cpp
	Region.cpp
	Resource.cpp
	ResourceDesc.cpp
	ResourceManager.cpp
	ResourceSource.cpp
	SaveGameIterator.cpp
	SaveGameMgr.cpp
	ScriptEngine.cpp
	ScriptedAnimation.cpp
	SoundMgr.cpp
	Spell.cpp
	SpellMgr.cpp
	Spellbook.cpp
	Sprite2D.cpp
	SpriteCover.cpp
	Store.cpp
	StoreMgr.cpp
	StringMgr.cpp
	SymbolMgr.cpp
	TableMgr.cpp
	Tile.cpp
	TileMap.cpp
	TileMapMgr.cpp
	TileOverlay.cpp
	TileSetMgr.cpp
	Variables.cpp
	Video.cpp
	WindowMgr.cpp
	WorldMap.cpp
	WorldMapMgr.cpp
	GameScript/Actions.cpp
	GameScript/GSUtils.cpp
	GameScript/GameScript.cpp
	GameScript/Matching.cpp
	GameScript/Objects.cpp
	GameScript/Triggers.cpp
	GUI/Button.cpp
	GUI/Console.cpp
	GUI/Control.cpp
	GUI/EventMgr.cpp
	GUI/GameControl.cpp
	GUI/Label.cpp
	GUI/MapControl.cpp
	GUI/Progressbar.cpp
	GUI/ScrollBar.cpp
	GUI/Slider.cpp
	GUI/TextArea.cpp
	GUI/TextEdit.cpp
	GUI/Window.cpp
	GUI/WorldMapControl.cpp
	Scriptable/Actor.cpp
	Scriptable/Container.cpp
	Scriptable/Door.cpp
	Scriptable/InfoPoint.cpp
	Scriptable/Scriptable.cpp
	Scriptable/PCStatStruct.cpp
	System/DataStream.cpp
	System/FileStream.cpp
	System/MemoryStream.cpp
	System/Logging.cpp
	System/SlicedStream.cpp
	System/String.cpp
	System/VFS.cpp
	)

if (STATIC_LINK)
	ADD_LIBRARY(gemrb_core STATIC ${gemrb_core_LIB_SRCS})
else (STATIC_LINK)
	ADD_LIBRARY(gemrb_core SHARED ${gemrb_core_LIB_SRCS})
	IF(WIN32)
	  INSTALL(TARGETS gemrb_core RUNTIME DESTINATION ${LIB_DIR})
	ELSE(WIN32)
	  INSTALL(TARGETS gemrb_core LIBRARY DESTINATION ${LIB_DIR})
	ENDIF(WIN32)
endif (STATIC_LINK)

SET_TARGET_PROPERTIES(gemrb_core PROPERTIES
	COMPILE_DEFINITIONS
	"PLUGINDIR=\"${PLUGIN_DIR}\";DATADIR=\"${DATA_DIR}\";SYSCONFDIR=\"${SYSCONF_DIR}\""
	)

=== gemrb/plugins/CMakeLists.txt ===
ADD_SUBDIRECTORY( 2DAImporter )
ADD_SUBDIRECTORY( ACMReader )
ADD_SUBDIRECTORY( AREImporter )
ADD_SUBDIRECTORY( BAMImporter )
ADD_SUBDIRECTORY( BIFImporter )
ADD_SUBDIRECTORY( BIKPlayer )
ADD_SUBDIRECTORY( BMPImporter )
ADD_SUBDIRECTORY( BMPWriter )
ADD_SUBDIRECTORY( CHUImporter )
ADD_SUBDIRECTORY( CREImporter )
ADD_SUBDIRECTORY( DLGImporter )
ADD_SUBDIRECTORY( DirectoryImporter )
ADD_SUBDIRECTORY( EFFImporter )
ADD_SUBDIRECTORY( FXOpcodes )
ADD_SUBDIRECTORY( GAMImporter )
ADD_SUBDIRECTORY( GUIScript )
ADD_SUBDIRECTORY( IDSImporter )
ADD_SUBDIRECTORY( INIImporter )
ADD_SUBDIRECTORY( ITMImporter )
ADD_SUBDIRECTORY( IWDOpcodes )
ADD_SUBDIRECTORY( KEYImporter )
ADD_SUBDIRECTORY( MOSImporter )
ADD_SUBDIRECTORY( MUSImporter )
ADD_SUBDIRECTORY( MVEPlayer )
ADD_SUBDIRECTORY( NullSound )
ADD_SUBDIRECTORY( OGGReader )
ADD_SUBDIRECTORY( OpenALAudio )
ADD_SUBDIRECTORY( PLTImporter )
ADD_SUBDIRECTORY( PNGImporter )
ADD_SUBDIRECTORY( PROImporter )
ADD_SUBDIRECTORY( PSTOpcodes )
ADD_SUBDIRECTORY( SAVImporter )
ADD_SUBDIRECTORY( SDLAudio )
ADD_SUBDIRECTORY( SDLVideo )
ADD_SUBDIRECTORY( SPLImporter )
ADD_SUBDIRECTORY( STOImporter )
ADD_SUBDIRECTORY( TISImporter )
ADD_SUBDIRECTORY( TLKImporter )
ADD_SUBDIRECTORY( WAVReader )
ADD_SUBDIRECTORY( WEDImporter )
ADD_SUBDIRECTORY( WMPImporter )
ADD_SUBDIRECTORY( ZLibManager )

if (STATIC_LINK)
	SET(plugins ${plugins} PARENT_SCOPE)
endif (STATIC_LINK)

=== gemrb/override/iwd2/CMakeLists.txt ===
ADD_GEMRB_OVERRIDE (iwd2)

=== gemrb/plugins/BAMImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (BAMImporter BAMImporter.cpp)

=== debian/changelog ===
gemrb (0.6.5-2) unstable; urgency=low
  New features:
    - quickspell support
    - keymap.ini handling
    - yet more unhardcoded PST projectiles
    - area comments, party npc interactions
    - ios port and enhanced touchscreen support
  Improved features:
    - performance
    - squirrels and other small game don't die instantly
    - stores and stacking
    - effects, triggers, actions, dialogs
    - secret door detection, turning undead
    - bugfixes and internal cleanups
  Applied patches:
    ios support patches from Brad Allred
    android and touchscreen patches from Beholder.
  More info: http://www.gemrb.org/
 -- Nerdknight <nerdknight@gmail.com>  Sat, 6 Aug 2011 04:21:53 -0300

=== debian/control ===
Source: gemrb
Section: user/games
Priority: extra
Maintainer: Nerdknight <nerdknight@gmail.com>
Build-Depends: debhelper (>= 5), autotools-dev, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev
Standards-Version: 3.7.2
Homepage: http://gemrb.sourceforge.net

Package: gemrb
Architecture: armel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:  GemRB is an open-source implementation of Bioware's Infinity Engine.
 GemRB (Game engine made with preRendered Background) is a portable 
 open-source implementation of Bioware's Infinity Engine.
 .
 You need to own the original games in order to play them.
XB-Maemo-Upgrade-Description: Version 0.6.5 changes:
 New features:
    - quickspell support
    - keymap.ini handling
    - yet more unhardcoded PST projectiles
    - area comments, party npc interactions
    - ios port and enhanced touchscreen support
 Improved features:
    - performance
    - squirrels and other small game don't die instantly
    - stores and stacking
    - effects, triggers, actions, dialogs
    - secret door detection, turning undead
    - bugfixes and internal cleanups
 Applied patches:
    ios support patches from Brad Allred
    android and touchscreen patches from Beholder.
XB-Maemo-Display-Name: GemRB
XB-Maemo-Icon-26:
 iVBORw0KGgoAAAANSUhEUgAAAEAAAABACAYAAACqaXHeAAAABHNCSVQICAgI
 fAhkiAAAAAlwSFlzAAAEdgAABHYBvT2qxwAAABl0RVh0U29mdHdhcmUAd3d3
 Lmlua3NjYXBlLm9yZ5vuPBoAAAYISURBVHja7Zt7UFRVHMeBFZCHsLDBiqDM
 iiGLiBQpCEyCOMVDcQER8sEoVkzAENMQYsIoFaZlDsxgQgyaKWM2zTRN03um
 VLRySkfTprQxUAsNexhigoG/fme9S8ty755zl717BfY38/mDmd17ft/P7t57
 7jkXBwBwkAOsIsRbrvEH+5ApfD5yB1GOOwFYy5B+BMadAKw05DYXfnwJwEpE
 bhmFHz8CsGKRGybhx4cArDnIXzzhx74ArDCkSyD82BaApUF+MRN+zAvYTAlv
 F2AXYBdgF2AXYBdgF2AXYBdgFzDaBWC5IpFICrIOqUa+ZhCwG2kUQR1SgaxE
 kpCpsgnAckOykFbkb4awUnGKEz7LJgKw1EgT0iNjaCGOI3GSCOC+5pVI9z0Y
 3BTyrQyymgCsBOTnURDcGPIN1Y1YAFYe0jvKwhsYQMosFoC1gdvAgFFOPeIo
 SgDWtjEQ3JjnmAVg5Y6x8IafQwpVALmeWniJIwMcQZqRGuQj2ns0gdUwI7CR
 Gc2UHRCgKgafSSngPCHAEgl/IiGCArAmIedFHvQnbqd3stipcFZqOzykPQ8J
 kSAajd9JUHu+C27OiWIlfGJOwPMiDkTmA88iLpbeC6zMvA456V0wV9suKnxc
 xE3QqPpgui/oCZj0OSgc/cRISBgmAMtXxCSHzAm0I70ZIgLWLgdYltYJ87SX
 mQVEhpwYDG9gmrIDXBRRrAIO8Ql4ifHNJxB/a9wNGgQQdI9chJjwq0wCQgO/
 GCaAoPHpAWeFllVC0qAALD/GE98VZIq1boeNBRAyki9A7KzfqQKm+53lFUAI
 8j4Njo4TWQQ0GwsoYnjDv0i8NdcDTAUQ0hf+iBKu8wbXLQIoXdcLMWH9ggII
 Kvd6FgGdZHJkaPZDhjc0WXtBhE8AIeXhMzA/ogcWxQAU4N816wH24Ohv779L
 cwNA9P3CAjS+t0HhpGaREE0aded5cMGUXrGLDyMRQFhfdgUO7vs/tCmNdQBR
 GmEJSrcNLAI2kUYzGF64R4olMXMCWl4TDm+g4VWA2cH8AqZ6nwMy/af08BZp
 dDuDAJ0tBTy5Csx++sbUbwOYFXQ3dLDPJZimOgwzg47jeaQHXJwDqZdD0ugB
 hq+/py0FVD7NFt5AeXEnRM0YPpny8oinCfjBgbNg7kUnpVoVFhKw/QVxAorX
 8F8u/ZQraALIozsO5ygv+sBCAZU0AblLfuUVsHuXOAFLF/ILmKwqpAkgJ3/q
 9LfFQgFraQLSk78cFv6p1XdEhX+jSXjCpPJaShNw0YHhBFhnoYBU2rETYw/o
 Q6/O/gPydMegYMVRqCq/BntfZxfw4kZhAZ7uc1lWkSUT8ADt2NFRpVBa+D3U
 Vg3AlmoYZOsmgDeb2QQUruYPPz+iG6fELrRs70kpwJ92bF+fEKitvjMkvIFt
 KGFfC11A+gJ+AWHB77BMhHZKJoCT8B3t+AWrPuMVoJdQA7B/N//v/hW8UlSU
 DEB02Fe8ApSeySwCsqQWsIV2fG1ohqAAwssooWXXTdi5A2BzJUBJwdCTZn52
 H0r4Zujt8tS9LOH7uBUwSQXEsdyb52a2mpWge7RNcMqsP4lm/YMSTunDx4R3
 wQSFikXAp1yPkgpwQq7SxnB19YLykguCApYvuWRWAGGF7gZKOMsy+TFQLLkA
 boBylobU/hFQUdoxLPwzRZep4QlrcvohcuZG1vC/IR62EuDGLT5QG/Nw94Mn
 8g8NEZCX2UYNn7O4A9T3JYhZFC0z6k9aAdwgxazNKZycIT6mbPAnoUs5ajb8
 gthWvOvzFhP+MtnptrUAF+SMmPV7R0cn/RVi/oP1kJp0WH/fkJ99C3LS2yEt
 6QjMCa8CpZfWks2Rx0x6k14AN1CozE+SEBp4+rKNAG6wTBnDH0OcZRXADVgj
 Q/gOJECgH9sK4AYt5TZTbRH+W9N9S9kFcAMvtsGDVu8brvf3nABu8Nnclrq1
 g3dzK1IKhh7kE2DURA7SbqWHIMjzCWoRY8svgGtkIvI48rHJv9eynuTI8n6E
 BePeGwJMmvJB1nCfJtm2O41c4xYxydZ8G3IQqUXmjWSs/wDHL4xdfg+anQAA
 AABJRU5ErkJggg==

## gemrb 0.6.6-1

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,9 @@
 if (NOT LAYOUT)
 	if (WIN32)
 		set(LAYOUT "home")
-	else (WIN32)
+	elseif (APPLE)
+		set(LAYOUT "library")
+	else (APPLE)
 		set(LAYOUT "fhs")
 	endif (WIN32)
 endif (NOT LAYOUT)
@@ -91,7 +93,7 @@
 	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
 	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
 	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
-else (${LAYOUT} MATCHES "opt")
+elseif (${LAYOUT} MATCHES "opt")
 	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib )
 	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
 	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/ )
@@ -102,6 +104,18 @@
 	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
 	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
 	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
+else (${LAYOUT} MATCHES "library") # mac
+	SET_PATH( APPLICATION_SUPPORT $ENV{HOME}/Library/Application\ Support/GemRB)
+	SET_PATH( LIB_DIR ${APPLICATION_SUPPORT}) #should go in app bundle!
+	SET_PATH( PLUGIN_DIR ${APPLICATION_SUPPORT}/plugins )
+	SET_PATH( DATA_DIR ${APPLICATION_SUPPORT} )
+	SET_PATH( MAN_DIR /usr/share/man/man6 )
+	SET_PATH( BIN_DIR /Applications )
+	SET_PATH( SYSCONF_DIR ${APPLICATION_SUPPORT})
+	SET_PATH( DOC_DIR ${APPLICATION_SUPPORT} )
+	SET_PATH( ICON_DIR ${APPLICATION_SUPPORT}/share/pixmaps )
+	SET_PATH( SVG_DIR ${APPLICATION_SUPPORT}/share/icons/hicolor/scalable/apps )
+	SET_PATH( MENU_DIR ${APPLICATION_SUPPORT}/share/applications )
 endif (${LAYOUT} MATCHES "home")
 
 # check if this is a release version
@@ -256,8 +270,9 @@
 ENDIF(NOT WIN32)
 
 IF(APPLE)
-	FIND_LIBRARY(SDL_MAIN_LIBRARY_PATH SDLmain)
 	FIND_LIBRARY(COCOA_LIBRARY_PATH Cocoa)
+	SET (MAC_C_FLAGS "${CMAKE_C_FLAGS} -x objective-c -DTARGET_OS_MAC")
+	SET (CMAKE_C_FLAGS ${MAC_C_FLAGS})
 ENDIF(APPLE)
 
 CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake_config.h.in
@@ -265,19 +280,33 @@
 
 #Plugin addition macro
 MACRO(ADD_GEMRB_PLUGIN plugin_name)
-	if (STATIC_LINK)
-		ADD_LIBRARY(${plugin_name} STATIC ${ARGN})
-		set(plugins "${plugins};${plugin_name}" PARENT_SCOPE)
-	else (STATIC_LINK)
-		ADD_LIBRARY(${plugin_name} MODULE ${ARGN})
-		if (NOT UNSAFE_PLUGIN)
-			TARGET_LINK_LIBRARIES(${plugin_name} gemrb_core ${CMAKE_THREAD_LIBS_INIT})
-		endif (NOT UNSAFE_PLUGIN)
-		INSTALL(TARGETS ${plugin_name} DESTINATION ${PLUGIN_DIR})
-	endif (STATIC_LINK)
-	SET_TARGET_PROPERTIES(${plugin_name} PROPERTIES PREFIX ""
-		INSTALL_RPATH ${LIB_DIR}
-		LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/gemrb/plugins)
+	SET (PLUGIN_BUILD_FILES ${ARGN})
+	if (${ARGV1} STREQUAL "COCOA")
+		LIST(REMOVE_ITEM PLUGIN_BUILD_FILES "COCOA")
+		#this is an Apple thing
+		if (APPLE)
+			SET_SOURCE_FILES_PROPERTIES(
+				CocoaWrapper.m
+				PROPERTIES LANGUAGE C
+			)
+			message(STATUS "Will link ${plugin_name} plugin to: ${BUNDLE_LOADER}")
+			SET (PLUGIN_BUILD_FILES ${PLUGIN_BUILD_FILES} CocoaWrapper.m)
+		endif (APPLE)
+	endif (${ARGV1} STREQUAL "COCOA")
+
+        if (STATIC_LINK)
+                ADD_LIBRARY(${plugin_name} STATIC ${PLUGIN_BUILD_FILES})
+                set(plugins "${plugins};${plugin_name}" PARENT_SCOPE)
+        else (STATIC_LINK)
+                ADD_LIBRARY(${plugin_name} MODULE ${PLUGIN_BUILD_FILES})
+                if (NOT UNSAFE_PLUGIN)
+                        TARGET_LINK_LIBRARIES(${plugin_name} gemrb_core ${CMAKE_THREAD_LIBS_INIT})
+                endif (NOT UNSAFE_PLUGIN)
+                INSTALL(TARGETS ${plugin_name} DESTINATION ${PLUGIN_DIR})
+        endif (STATIC_LINK)
+        SET_TARGET_PROPERTIES(${plugin_name} PROPERTIES PREFIX ""
+                INSTALL_RPATH ${LIB_DIR}
+                LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/gemrb/plugins)
 ENDMACRO(ADD_GEMRB_PLUGIN)
 
 #gemrb overrides macro
@@ -298,47 +327,3 @@
 INSTALL( FILES artwork/gemrb-logo.png DESTINATION ${ICON_DIR} RENAME gemrb.png )
 INSTALL( FILES artwork/logo04-rb_only.svg DESTINATION ${SVG_DIR} RENAME gemrb.svg )
 INSTALL( FILES gemrb.desktop DESTINATION ${MENU_DIR} )
-INSTALL( FILES README INSTALL COPYING NEWS AUTHORS DESTINATION ${DOC_DIR} )
-
-CONFIGURE_FILE(
-	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
-	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-	IMMEDIATE @ONLY
-)
-
-# copy the variable, since the file uses @VERSION@
-set(VERSION ${GEMRB_VERSION})
-CONFIGURE_FILE(
-	"${CMAKE_CURRENT_SOURCE_DIR}/gemrb.spec.in"
-	"${CMAKE_CURRENT_BINARY_DIR}/gemrb.spec"
-	IMMEDIATE @ONLY
-)
-
-ADD_CUSTOM_TARGET( uninstall
-	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" )
-
-# make dist for a gzipped tarball of current HEAD
-set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${GEMRB_VERSION})
-add_custom_target( dist
-	COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
-		| gzip --best > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.gz
-	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-)
-
-# pretty-print options macro
-# as of 2.8 cmake does not support anything like EVAL
-MACRO(PRINT_OPTION option name)
-if (${option})
-	message(STATUS "  ${name}: ${option}")
-else()
-	message(STATUS "  ${name}: disabled")
-endif()
-ENDMACRO(PRINT_OPTION)
-
-message(STATUS "")
-message(STATUS "These are the configured paths:")
-message(STATUS "  PREFIX: ${CMAKE_INSTALL_PREFIX}")
-message(STATUS "  LIB_DIR: ${LIB_DIR}")
-message(STATUS "  PLUGIN_DIR: ${PLUGIN_DIR}")
-message(STATUS "  BIN_DIR: ${BIN_DIR}")
-message(STATUS "  DATA_DIR: ${DATA_DIR}")

=== gemrb/CMakeLists.txt ===
ADD_SUBDIRECTORY( core )

IF(APPLE)
	SET_SOURCE_FILES_PROPERTIES(
		CocoaWrapper.h
		CocoaWrapper.m
		PROPERTIES LANGUAGE C
	)

	SET_SOURCE_FILES_PROPERTIES(
		../artwork/gemrb.icns
		PROPERTIES MACOSX_PACKAGE_LOCATION Resources
	)
	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE CocoaWrapper.m GemRB.cpp ../artwork/gemrb.icns)
	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader ${BUNDLE_LOADER}")
ELSE(APPLE)
	ADD_EXECUTABLE(gemrb GemRB.cpp )
ENDIF(APPLE)
# we need to add gemrb target before processing plugins or COCOA plugins don't work right.

ADD_SUBDIRECTORY( plugins )
ADD_SUBDIRECTORY( override )
ADD_SUBDIRECTORY( GUIScripts )
ADD_SUBDIRECTORY( docs )
ADD_SUBDIRECTORY( tests )

SET_TARGET_PROPERTIES(gemrb PROPERTIES INSTALL_RPATH ${LIB_DIR})
INCLUDE_DIRECTORIES( ${SDL_INCLUDE_DIR} )
IF(WIN32)
 TARGET_LINK_LIBRARIES(gemrb gemrb_core)
ELSE(WIN32)
 IF(APPLE)
	if (STATIC_LINK)
		TARGET_LINK_LIBRARIES(gemrb
			  ${COCOA_LIBRARY_PATH} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
			 gemrb_core ${plugins}  -Wl,-all_load)
	else (STATIC_LINK)
		TARGET_LINK_LIBRARIES(gemrb gemrb_core
			  ${COCOA_LIBRARY_PATH} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
	endif (STATIC_LINK)
 ELSE(APPLE)
  if (STATIC_LINK)
	  TARGET_LINK_LIBRARIES(gemrb ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
		  -Wl,--whole-archive gemrb_core ${plugins} -Wl,--no-whole-archive)
  else (STATIC_LINK)
	  TARGET_LINK_LIBRARIES(gemrb gemrb_core ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
  endif (STATIC_LINK)
 ENDIF(APPLE)
ENDIF(WIN32)

# preconfigure the sample config with the selected paths
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/GemRB.cfg.sample.in"
  "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample"
  IMMEDIATE @ONLY
)

INSTALL( TARGETS gemrb DESTINATION ${BIN_DIR} )
INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample" GemRB.cfg.noinstall.sample DESTINATION ${SYSCONF_DIR} )

=== gemrb/core/CMakeLists.txt ===
--- 
+++ 
@@ -137,3 +137,8 @@
 	COMPILE_DEFINITIONS
 	"PLUGINDIR=\"${PLUGIN_DIR}\";DATADIR=\"${DATA_DIR}\";SYSCONFDIR=\"${SYSCONF_DIR}\""
 	)
+
+IF (APPLE)
+	SET_TARGET_PROPERTIES(gemrb_core PROPERTIES
+	INSTALL_NAME_DIR ${LIB_DIR})
+ENDIF (APPLE)

=== gemrb/plugins/SDLVideo/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${SDL_INCLUDE_DIR} )

ADD_GEMRB_PLUGIN (SDLVideo COCOA SDLVideo.cpp)
TARGET_LINK_LIBRARIES( SDLVideo ${SDL_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${COCOA_LIBRARY_PATH})

=== debian/changelog ===
gemrb (0.6.6-1) unstable; urgency=low
  New features
    -aura pollution and cleansing, casting interruption
    -formation rotation
    -bounty encounters
    -npclevel.2da support
    -initial mac bundle support
    -fatigue
    -backstab on condition (like in ToBEx)
  Improved features
    -effects, triggers, actions
    -keyboard shortcuts (F1-F12), touchscreen ui, scrolling
    -hitpoint gain, thieving skill boni
    -combat, spellcasting, iwd sounds
    -PST inventory, PST spells
    -bugfixes

  More info: http://www.gemrb.org/
 -- Nerdknight <nerdknight@gmail.com>  Thu, 20 Oct 2011 21:25:37 -0300

=== debian/control ===
--- 
+++ 
@@ -14,23 +14,22 @@
  open-source implementation of Bioware's Infinity Engine.
  .
  You need to own the original games in order to play them.
-XB-Maemo-Upgrade-Description: Version 0.6.5 changes:
- New features:
-    - quickspell support
-    - keymap.ini handling
-    - yet more unhardcoded PST projectiles
-    - area comments, party npc interactions
-    - ios port and enhanced touchscreen support
- Improved features:
-    - performance
-    - squirrels and other small game don't die instantly
-    - stores and stacking
-    - effects, triggers, actions, dialogs
-    - secret door detection, turning undead
-    - bugfixes and internal cleanups
- Applied patches:
-    ios support patches from Brad Allred
-    android and touchscreen patches from Beholder.
+XB-Maemo-Upgrade-Description: Version 0.6.6 changes:
+ New features
+    -aura pollution and cleansing, casting interruption
+    -formation rotation
+    -bounty encounters
+    -npclevel.2da support
+    -initial mac bundle support
+    -fatigue
+    -backstab on condition (like in ToBEx)
+ Improved features
+    -effects, triggers, actions
+    -keyboard shortcuts (F1-F12), touchscreen ui, scrolling
+    -hitpoint gain, thieving skill boni
+    -combat, spellcasting, iwd sounds
+    -PST inventory, PST spells
+    -bugfixes
 XB-Maemo-Display-Name: GemRB
 XB-Maemo-Icon-26:
  iVBORw0KGgoAAAANSUhEUgAAAEAAAABACAYAAACqaXHeAAAABHNCSVQICAgI

## gemrb 0.7.0maemo3

=== debian/changelog ===
gemrb (0.7.0maemo3) unstable; urgency=low
  New features
    -one can play through the whole Baldur's Gate saga
    -custom TTF fonts support
    -arbitrarily sortable casting list
    -ios configuration interface, xcode project
    -more pst spawn ini flags, individual critical hit animations

  Improved features
    -resting, comment timing, actions
    -drop caps, keybindings, sdl 1.3 input
    -bugfixes, cleanups

  More info: http://www.gemrb.org/
  Maemo:
    -Added libsdl-ttf2.0-dev to build dependency
    -Changed bugtracker to http://talk.maemo.org/showthread.php?p=1153973
 -- Nerdknight <nerdknight@gmail.com>  Mon, 25 Jan 2012 10:53:00 -0300

## gemrb 0.7.0maemo4

=== CMakeLists.txt ===
--- 
+++ 
@@ -201,6 +201,14 @@
 	MESSAGE(WARNING "If you want to build the SDL_mixer plugin, install SDL_mixer first.")
 ENDIF()
 
+INCLUDE(FindSDL_ttf)
+IF(SDLTTF_FOUND)
+	MESSAGE(STATUS "Looking for SDL_ttf: found")
+ELSE()
+	MESSAGE(WARNING "Looking for SDL_ttf: not found!")
+	MESSAGE(WARNING "If you want to build the SDL_ttf plugin, install SDL_ttf first.")
+ENDIF()
+
 INCLUDE(FindPNG)
 IF(PNG_FOUND)
 	MESSAGE(STATUS "Looking for libPNG: found")
@@ -274,6 +282,13 @@
 	SET (MAC_C_FLAGS "${CMAKE_C_FLAGS} -x objective-c -DTARGET_OS_MAC")
 	SET (CMAKE_C_FLAGS ${MAC_C_FLAGS})
 ENDIF(APPLE)
+
+IF (MINGW)
+	SET (WIN32_USE_STDIO Yes)
+ENDIF ()
+if (WIN32_USE_STDIO)
+	SET (NOCOLOR Yes)
+ENDIF()
 
 CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake_config.h.in
 	${CMAKE_CURRENT_BINARY_DIR}/config.h ESCAPE_QUOTES)
@@ -322,8 +337,3 @@
 	IMMEDIATE @ONLY
 )
 
-ADD_SUBDIRECTORY( gemrb )
-INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/gemrb.6" DESTINATION ${MAN_DIR} )
-INSTALL( FILES artwork/gemrb-logo.png DESTINATION ${ICON_DIR} RENAME gemrb.png )
-INSTALL( FILES artwork/logo04-rb_only.svg DESTINATION ${SVG_DIR} RENAME gemrb.svg )
-INSTALL( FILES gemrb.desktop DESTINATION ${MENU_DIR} )

=== gemrb/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 IF(APPLE)
 	SET_SOURCE_FILES_PROPERTIES(
 		CocoaWrapper.h
-		CocoaWrapper.m
+		../apple/CocoaWrapper/mac/CocoaWrapper.m
 		PROPERTIES LANGUAGE C
 	)
 
@@ -12,7 +12,7 @@
 		PROPERTIES MACOSX_PACKAGE_LOCATION Resources
 	)
 	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
-	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE CocoaWrapper.m GemRB.cpp ../artwork/gemrb.icns)
+	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.m GemRB.cpp ../artwork/gemrb.icns)
 	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
 	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader ${BUNDLE_LOADER}")
 ELSE(APPLE)

=== gemrb/GUIScripts/CMakeLists.txt ===
FILE( GLOB FILES_TO_INSTALL *.py )

INSTALL( FILES ${FILES_TO_INSTALL} DESTINATION ${DATA_DIR}/GUIScripts )

ADD_SUBDIRECTORY( bg1 )
ADD_SUBDIRECTORY( bg2 )
ADD_SUBDIRECTORY( iwd )
ADD_SUBDIRECTORY( iwd2 )
ADD_SUBDIRECTORY( pst )

INSTALL( DIRECTORY test DESTINATION ${DATA_DIR}/GUIScripts )

=== gemrb/plugins/CMakeLists.txt ===
--- 
+++ 
@@ -36,6 +36,7 @@
 ADD_SUBDIRECTORY( STOImporter )
 ADD_SUBDIRECTORY( TISImporter )
 ADD_SUBDIRECTORY( TLKImporter )
+ADD_SUBDIRECTORY( TTFImporter )
 ADD_SUBDIRECTORY( WAVReader )
 ADD_SUBDIRECTORY( WEDImporter )
 ADD_SUBDIRECTORY( WMPImporter )

=== gemrb/GUIScripts/bg1/CMakeLists.txt ===
FILE( GLOB FILES_TO_INSTALL *.py )

INSTALL( FILES ${FILES_TO_INSTALL} DESTINATION ${DATA_DIR}/GUIScripts/bg1 )

=== gemrb/GUIScripts/iwd/CMakeLists.txt ===
FILE( GLOB FILES_TO_INSTALL *.py )

INSTALL( FILES ${FILES_TO_INSTALL} DESTINATION ${DATA_DIR}/GUIScripts/iwd )

=== gemrb/override/bg2/CMakeLists.txt ===
ADD_GEMRB_OVERRIDE (bg2)

=== gemrb/override/how/CMakeLists.txt ===
ADD_GEMRB_OVERRIDE (how)

=== debian/changelog ===
gemrb (0.7.0maemo4) unstable; urgency=low
  New features
    -one can play through the whole Baldur's Gate saga
    -custom TTF fonts support
    -arbitrarily sortable casting list
    -ios configuration interface, xcode project
    -more pst spawn ini flags, individual critical hit animations

  Improved features
    -resting, comment timing, actions
    -drop caps, keybindings, sdl 1.3 input
    -bugfixes, cleanups

  More info: http://www.gemrb.org/
  Maemo:
    -Added libsdl-ttf2.0-dev to build dependency
    -Changed bugtracker to http://talk.maemo.org/showthread.php?p=1153973
 -- Nerdknight <nerdknight@gmail.com>  Wed, 25 Jan 2012 11:45:50 -0300

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: user/games
 Priority: extra
 Maintainer: Nerdknight <nerdknight@gmail.com>
-Build-Depends: debhelper (>= 5), autotools-dev, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev
+Build-Depends: debhelper (>= 5), cmake, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev,libsdl-ttf2.0-dev
 Standards-Version: 3.7.2
 Homepage: http://gemrb.sourceforge.net
 
@@ -14,23 +14,19 @@
  open-source implementation of Bioware's Infinity Engine.
  .
  You need to own the original games in order to play them.
-XB-Maemo-Upgrade-Description: Version 0.6.6 changes:
+XB-Maemo-Upgrade-Description: Version 0.7.0 changes:
  New features
-    -aura pollution and cleansing, casting interruption
-    -formation rotation
-    -bounty encounters
-    -npclevel.2da support
-    -initial mac bundle support
-    -fatigue
-    -backstab on condition (like in ToBEx)
+    -one can play through the whole Baldur's Gate saga
+    -custom TTF fonts support
+    -arbitrarily sortable casting list
+    -ios configuration interface, xcode project
+    -more pst spawn ini flags, individual critical hit animations
  Improved features
-    -effects, triggers, actions
-    -keyboard shortcuts (F1-F12), touchscreen ui, scrolling
-    -hitpoint gain, thieving skill boni
-    -combat, spellcasting, iwd sounds
-    -PST inventory, PST spells
-    -bugfixes
+    -resting, comment timing, actions
+    -drop caps, keybindings, sdl 1.3 input
+    -bugfixes, cleanups
 XB-Maemo-Display-Name: GemRB
+XSBC-Bugtracker: http://talk.maemo.org/showthread.php?p=1153973
 XB-Maemo-Icon-26:
  iVBORw0KGgoAAAANSUhEUgAAAEAAAABACAYAAACqaXHeAAAABHNCSVQICAgI
  fAhkiAAAAAlwSFlzAAAEdgAABHYBvT2qxwAAABl0RVh0U29mdHdhcmUAd3d3

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2 -mcpu=cortex-a8 -mtune=cortex-a8 -mfpu=neon -rpath,/opt/maemo/usr/lib
endif

config.status:
	dh_testdir
	# Add here commands to configure the package.
	sh configureCMake.sh -DPREFIX=/usr -DLIB_DIR=/usr/lib -DDISABLE_WERROR=true -DCMAKE_SKIP_RPATH=true -DCMAKE_BUILD_TYPE=Debug 
build: 

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	# Add here commands to clean up after the build process.
	#-$(MAKE) -C debian/build distclean
	rm -rf debian/build
	rm -rf debian/gemrb
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean 

install: config.status
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/gemrb.
	$(MAKE) -C debian/build DESTDIR=$(CURDIR)/debian/gemrb install
	cp $(CURDIR)/debian/build/gemrb/gemrb $(CURDIR)/debian/gemrb/usr/bin
	dh_install --sourcedir=$(CURDIR)/debian/gemrb

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
#	dh_installdocs
#	dh_installexamples
#	dh_install
	dh_installmenu
	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	-maemo-optify
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## gemrb 0.7.0-maemo1

=== debian/changelog ===
gemrb (0.7.0-maemo1) unstable; urgency=low
  New features
    -one can play through the whole Baldur's Gate saga
    -custom TTF fonts support
    -arbitrarily sortable casting list
    -ios configuration interface, xcode project
    -more pst spawn ini flags, individual critical hit animations

  Improved features
    -resting, comment timing, actions
    -drop caps, keybindings, sdl 1.3 input
    -bugfixes, cleanups

  More info: http://www.gemrb.org/
 -- Nerdknight <nerdknight@gmail.com>  Sun, 8 Jan 2011 13:10:37 -0300

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: user/games
 Priority: extra
 Maintainer: Nerdknight <nerdknight@gmail.com>
-Build-Depends: debhelper (>= 5), cmake, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev,libsdl-ttf2.0-dev
+Build-Depends: debhelper (>= 5), cmake, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev
 Standards-Version: 3.7.2
 Homepage: http://gemrb.sourceforge.net
 
@@ -26,7 +26,6 @@
     -drop caps, keybindings, sdl 1.3 input
     -bugfixes, cleanups
 XB-Maemo-Display-Name: GemRB
-XSBC-Bugtracker: http://talk.maemo.org/showthread.php?p=1153973
 XB-Maemo-Icon-26:
  iVBORw0KGgoAAAANSUhEUgAAAEAAAABACAYAAACqaXHeAAAABHNCSVQICAgI
  fAhkiAAAAAlwSFlzAAAEdgAABHYBvT2qxwAAABl0RVh0U29mdHdhcmUAd3d3

## gemrb 0.7.0-maemo2

=== gemrb/core/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,7 @@
 	FactoryObject.cpp
 	FileCache.cpp
 	Font.cpp
+	FontManager.cpp
 	Game.cpp
 	GameData.cpp
 	GlobalTimer.cpp

=== gemrb/plugins/GUIScript/CMakeLists.txt ===
INCLUDE(FindPythonLibs)

INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
ADD_GEMRB_PLUGIN (GUIScript GUIScript.cpp PythonHelpers.cpp)
TARGET_LINK_LIBRARIES(GUIScript ${PYTHON_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_DL_LIBS})

=== gemrb/plugins/TTFImporter/CMakeLists.txt ===
IF (SDLTTF_LIBRARY)
	INCLUDE_DIRECTORIES( ${SDL_INCLUDE_DIR} ${SDLTTF_INCLUDE_DIR})

	ADD_GEMRB_PLUGIN (TTFImporter TTFFontManager.cpp )
	TARGET_LINK_LIBRARIES( TTFImporter ${SDL_LIBRARY} ${SDLTTF_LIBRARY} )
ENDIF (SDLTTF_LIBRARY)

=== debian/changelog ===
gemrb (0.7.0-maemo2) unstable; urgency=low
  New features
    -one can play through the whole Baldur's Gate saga
    -custom TTF fonts support
    -arbitrarily sortable casting list
    -ios configuration interface, xcode project
    -more pst spawn ini flags, individual critical hit animations

  Improved features
    -resting, comment timing, actions
    -drop caps, keybindings, sdl 1.3 input
    -bugfixes, cleanups

  More info: http://www.gemrb.org/
  Maemo:
    -Added libsdl-ttf2.0-dev to build dependency 
 -- Nerdknight <nerdknight@gmail.com>  Mon, 23 Jan 2012 20:08:00 -0300

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: user/games
 Priority: extra
 Maintainer: Nerdknight <nerdknight@gmail.com>
-Build-Depends: debhelper (>= 5), cmake, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev
+Build-Depends: debhelper (>= 5), cmake, libopenal-dev, python-support, python2.5-dev, libpng12-dev, libvorbis-dev, libsdl1.2-dev, zlib1g-dev,libsdl-ttf2.0-dev
 Standards-Version: 3.7.2
 Homepage: http://gemrb.sourceforge.net
